/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.benutzerverwaltung.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class RechteKonfigurationTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final String rechtAsString;
    public String getRechtAsString(){
      return rechtAsString;
    }

  public RechteKonfigurationTK(
String rechtAsString
  ) {
    super();


      this.rechtAsString = rechtAsString;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((rechtAsString == null) ? 0 : rechtAsString.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof RechteKonfigurationTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        RechteKonfigurationTK other = (RechteKonfigurationTK) obj;

                if (rechtAsString == null) {
          if (other.rechtAsString != null) {
            return false;
          }
        } else if (!rechtAsString.equals(other.rechtAsString)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return RechteKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(RechteKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL, RechteKonfigurationConstants.MESSAGE_KEY_RECHT_EINZAHL, rechtAsString));
        
        return result;
      }


            @Override
            public String toString() {
            return "RechteKonfigurationTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"rechtAsString="+rechtAsString
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(Messages messages) {
        return ""
                                      + messages.getMessageForMessageKey(RechteKonfigurationConstants.MESSAGE_KEY_RECHT_EINZAHL) + "=" + rechtAsString
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends RechteKonfiguration> java.util.Map<RechteKonfigurationTK, E> mappeRechteKonfigurationNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(RechteKonfiguration::getRechteKonfigurationTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<RechteKonfiguration, RechteKonfigurationTK> getRechteKonfigurationToTKFunction() {
                return RechteKonfiguration::getRechteKonfigurationTK;
                }

}
